//
// eval.h - header file for RenderDotC to compiled shader interface
//
// RenderDotC (R) is:
//      Copyright (c) 1996-2001 by Dot C Software, Inc.
//      All Rights Reserved.
// RenderDotC (R) is a registered trademark of Dot C Software, Inc.
//

#ifndef EVAL_H
#define EVAL_H
#if defined(__sgi) || (_MSC_VER >= 1000)
#pragma once
#endif

#include "ridefs.h"			// For RtInt
#include "evaldefs.h"			// For SLvar

#undef RI_IMPORT
#undef RI_EXPORT
//
// Under Borland and Visual C++, use __declspec
//
#if defined(__BORLANDC__) || defined(_MSC_VER)
    #define RI_EXPORT __declspec(dllexport)
    #define RI_IMPORT __declspec(dllimport)
//
// Otherwise, don't use
//
#else
    #define RI_EXPORT
    #define RI_IMPORT
#endif

struct SLuniform;
struct SLvarying;

#ifdef __cplusplus
extern "C" {
#endif

extern void RI_EXPORT interrogate(SO_TYPE *shadertype, size_t *usize,
    size_t *vsize, SLvar **vvars, SLvar **hvars);
extern void RI_EXPORT defaultUniform(SLuniform *u);
extern void RI_EXPORT defaultVarying(SLuniform *u, SLvarying *v,
    SLvarying *vlast);
extern void RI_EXPORT evaluate(SLuniform *u, RtInt gridx, RtInt gridy,
    SLvarying *v, SLvarying *vlast, RtBoolean rev);

#ifdef __cplusplus
}
#endif

#endif
