#ifndef SHADEOP_H
#define SHADEOP_H

/*
 * Guarantee C linkage (turn off name mangling under C++)
 */
#undef RI_EXTERNC
#ifdef __cplusplus
    #define RI_EXTERNC extern "C"
#else
    #define RI_EXTERNC
#endif

/*
 * Under Borland and Visual C++, use __declspec
 */
#undef RI_EXPORT
#if defined(__BORLANDC__) || defined(_MSC_VER)
    #define RI_EXPORT __declspec(dllexport)
#else
    #define RI_EXPORT
#endif

/*
 * Prototype for DSO shadeop method function.
 */
#define SHADEOP(name) RI_EXTERNC int RI_EXPORT name(void *initdata, int argc, void **argv)

/*
 * Prototype for DSO shadeop init function.
 */
#define SHADEOP_INIT(name) RI_EXTERNC void RI_EXPORT *name(int ctx, void *texturectx)

/*
 * Prototype for DSO shadeop shutdown function.
 */
#define SHADEOP_CLEANUP(name) RI_EXTERNC void RI_EXPORT name(void *initdata)

/*
 * The structure which defines the mapping between shadeops and their
 * methods, init, and cleanup functions.
 */
typedef struct {
    char *prototype;
    char *init;
    char *cleanup;
} SHADEOP_SPEC;

/*
 * A handy macro for declaration of the shadeop table.
 */
#define SHADEOP_TABLE(opname) SHADEOP_SPEC RI_EXPORT opname ## _shadeops[]

/*
 * Required structure for passing strings to DSO shadeops
 */
typedef struct {
    char *s;
    int buflen;			/* reserved */
    char padding[4*sizeof(float)-sizeof(char *)-sizeof(int)];
} STRING_DESC;

#endif
