/*
 * PROPRIETARY INFORMATION.  This software is proprietary to
 * Side Effects Inc., and is not to be reproduced,
 * transmitted, or disclosed in any way without written permission.
 *
 * Produced by:
 *	Mark Elendt
 *	Side Effects Software Inc.
 *	20 Maud St.
 *	Toronto, Ontario,  M5V 2M5
 *	Canada
 *	416-366-4607
 *
 */

light
attenshadow( 
    color	lightcolor = .8;
    float	     atten = 1E6;
    string	shadowname = "";
    point	      from = point "shader" (0,0,0);
    float	   samples = 16;
    float	     width = 1;
)
{
    float  factor;

    illuminate( from ) {
	factor = atten / (atten + sqrt(L.L));
	if (shadowname != "") {
	    factor *= 1 - shadow(shadowname, Ps, "samples", samples,
			    "swidth", width, "twidth", width);
	}
	Cl = factor * lightcolor;
    }
}
