/*
 * PROPRIETARY INFORMATION.  This software is proprietary to
 * Side Effects Inc., and is not to be reproduced,
 * transmitted, or disclosed in any way without written permission.
 *
 * Produced by:
 *	Mark Elendt
 *	Side Effects Software Inc.
 *	20 Maud St.
 *	Toronto, Ontario,  M5V 2M5
 *	Canada
 *	416-366-4607
 *
 */

light
attenshadowspot( 
    color	lightcolor = .8;
    string	shadowname = "";
    point	      from = point "shader" (0,0,0);
    point	        to = point "shader" (0,0,1);
    float	 coneangle = 30;
    float   conedeltaangle = 5;
    float beamdistribution = 1;
    float	   samples = 16;
    float	     width = 1;
    float	     atten = 1E6;
)
{
    uniform vector	A = (to - from) / length(to - from);
    uniform float	cosinside = cos(radians(coneangle*.5));
    uniform float	cosoutside = cos(radians(coneangle*.5+conedeltaangle));
    float		cosangle, rolloff, val, final, len;

    illuminate( from, A, 180 ) {
	len = length(L);
	cosangle = (L.A) / len;
	rolloff = smoothstep(cosoutside, cosinside, cosangle);

	if (rolloff > 0)
	     val = (atten*pow(rolloff, beamdistribution))/(atten+len);
	else val = rolloff;

	if (shadowname != "")
	{
	    final = val * (1 - shadow(shadowname, Ps, "samples", samples,
			    "swidth", width, "twidth", width));
	}
	else final = val;
	Cl = final * lightcolor;
    }
}
