/*
 * PROPRIETARY INFORMATION.  This software is proprietary to
 * Side Effects Inc., and is not to be reproduced,
 * transmitted, or disclosed in any way without written permission.
 *
 * Produced by:
 *	Mark Elendt
 *	Side Effects Software Inc.
 *	20 Maud St.
 *	Toronto, Ontario,  M5V 2M5
 *	Canada
 *	416-366-4607
 *
 */

light
attenspot( 
    float  intensity = 1;
    color  lightcolor = 1;
    point  from = point "shader" (0,0,0);	/* light position */
    point  to = point "shader" (0,0,1);
    float  coneangle = 30;
    float  conedeltaangle = 5;
    float  beamdistribution = 1;
    float  atten = 1.E6;			/* Default attenuation */
    )
{
    uniform vector	A = (to - from) / length(to - from);
    uniform float	cosinside = cos(radians(coneangle*.5));
    uniform float	cosoutside = cos(radians(coneangle*.5+conedeltaangle));
    float		cosangle, rolloff, val, len;

    illuminate( from, A, 180 ) {
	len = length(L);
	cosangle = (L.A) / len;
	val = atten*intensity / (atten + len);
	rolloff = smoothstep(cosoutside, cosinside, cosangle);
	     if (rolloff == 0) Cl = 0;
	else if (rolloff == 1) Cl = val*lightcolor;
	else {
	    val *= pow(rolloff, beamdistribution);
	    Cl = val * intensity * lightcolor;
	}
    }
}
